import Base from "../../Base";
import AxiosFetcherConditionsColumnOperators from "./AxiosFetcherConditionsColumnOperators";

class AxiosFetcherConditionsColumn extends Base {

    constructor(field, type) {

        super()

        switch(type)
        {
            case 'string':
            case 'integer':
                this.data = {value: null}
                break;
            default:
                this.data = {}
        }
    
        this.operators = new AxiosFetcherConditionsColumnOperators(field, type)
    }

    SetData(data) {
        _.each(data, (value, key) => this.data[key] = value)
        return this
    }

    SetCurrentOperator(current_operator) {
        this.operators.current_operator = current_operator
        return this
    }

    get columnOperators() {
        return this.operators.operators.All()
    }

    get currentOperator() {
        return this.operators.current_operator
    }
}

export default AxiosFetcherConditionsColumn