import Base from "../../Base";
import Collection from "../../Collection/Collection";
import AxiosFetcherConditionsColumnOperator from "./AxiosFetcherConditionsColumnOperator";

class AxiosFetcherConditionsColumnOperators extends Base {

    constructor(field, type) {
        super()

        this.field = field
        this.type = type
        this.operators = new Collection()
        this.current_operator = null

        this['Add' + _.capitalize(type) + 'Operators']()
    }

    AddStringOperators() {
        this.operators.Put('start', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '[value]%'"))
        this.operators.Put('end', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]'"))
        this.operators.Put('in', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]%'"))
    }

    AddIntegerOperators() {
        this.operators.Put('equal', new AxiosFetcherConditionsColumnOperator(this.field + " = [value]"))
        this.operators.Put('less', new AxiosFetcherConditionsColumnOperator(this.field + "  < [value]"))
        this.operators.Put('greater', new AxiosFetcherConditionsColumnOperator(this.field + " > [value]"))
    }
}

export default AxiosFetcherConditionsColumnOperators