import Modal from "../Base/Modal";
import Collection from "../../../Classes/Collection/Collection"
import AxiosCrud from "./../../../Classes/Axios/Crud/AxiosCrud"

class ModalCrud extends Modal {

    constructor(name) {
        super(name)

        /**
         * the blank record
         */
        this.blank = null

        /**
         * the work record
         */
        this.record = null

        /**
         * controls collection
         */
        this.controls = new Collection()

        /**
         * crud axios object
         */
        this.axios = new AxiosCrud()

    }

    SetBlankRecord(record) {
        Vue.set(this, 'blank', {})
        Vue.set(this, 'record', {})
        _.each(record, (value, key) => {
            Vue.set(this.blank, key, value)
            Vue.set(this.record, key, value)
        })
        return this
    }

    SetEndpoint(value) {
        this.axios.SetEndpoint(value)
        return this
    }

    AddControl(name, control) {
        this.controls.Put(name, control)
        return this
    }

    ResetRecord() {
        _.each(this.record, (value, key) => Vue.set(this.record, key, this.blank[key]))
    }

    get modalControls() {
        return this.controls.All()
    }
}

export default ModalCrud